/* ZxLinux start & end */

/*
	int zxlinux_start()	;;; return 0...error
	int zxlinux_end()	;;; return 0...error
 */
#include <zheaders.h>

#if 1
#define ZXLINUX_FILE	"F1:ZLNXKNL.BIN"
#else
#define ZXLINUX_FILE	"F1:ZXLINUX.BIN"
#endif
#define ZXLINUX_PROC	(0x7a786c6b)    // 'zxlk' linux-kernel


static OBJECT_NAME	zxlinux_code = 0;
static OBJECT_NAME	zxlinux_proc = 0;


#define SEND_QUEUE	(0x7a786c73)    // 'zxls' linux-send-queue
#define SEND_BUFFER_LEN	(128)
static int send_queue_created = 0;


static void
zxlinux_queue_dispose(OBJECT_NAME qname)
{
	QUEUE_PBOX pbox;
	unsigned short buf[SEND_BUFFER_LEN];
	  /**/
//==	TmpAlert("zxlinux_queue_dispose");
        while(queue_delete(SEND_QUEUE) == -1){
//==		TmpAlert("zxlinux_queue_dispose: queue_delete error");
		pbox.timeout = 0;
		pbox.data = (char*)buf;
		pbox.size = sizeof(buf);
		if(queue_read(SEND_QUEUE, &pbox) < 0){
//==			TmpAlert("zxlinux_queue_dispose: queue_read error");
			break;
		}
	}
//==	TmpAlert("zxlinux_queue_dispose: queue_delete ok");
}


static int
zxlinux_send(OBJECT_NAME qname, unsigned char *buf, int len)
{
	int		r;
	unsigned char	*p, *q;
	QUEUE_PBOX	pbox;
	  /**/
	if(send_queue_created == 0){
		goto SEND_QUEUE_CREATE;
	}
	for(q = buf + len; buf < q;){
		p = buf + SEND_BUFFER_LEN;
		if(p > q){
			p = q;
		}
		for(;;){
			pbox.timeout = 2;
			pbox.data = buf;
			pbox.size = p - buf;
			if((r = queue_write(SEND_QUEUE, &pbox)) == -1){
		SEND_QUEUE_CREATE:
				if(queue_create(SEND_QUEUE, 64, SEND_BUFFER_LEN * sizeof(buf[0])) < 0 && send_queue_created != 0){
					return -1;
				}
				send_queue_created = 1;
			}else if(r == -2){
				return -2;
			}else{
				break;
			}
		}
		buf = p;
	}
	return 0;
}


void
zxlinux_sendchar(int data)
{
	unsigned char	buf[2];
	buf[0] = 1;
	buf[1] = data;
	zxlinux_send(SEND_QUEUE,buf,2);
}


void
zxlinux_sendstring(char *str)
{
	int	r;
	unsigned char	*p, *e, buf[256];
	  /**/
	e = buf + sizeof(buf);
	p = buf;
	*p++ = 1;
	for(; p < e && *str != 0; ++str){
		*p++ = *(unsigned char*)str;
	}
	r = zxlinux_send(SEND_QUEUE,buf,p-buf);
	if(r != 0){
		ValDump("zxlinux_sendstring: zxlinux_send()",r,1);
	}
}


void
zxlinux_sendcmd(int data)
{
	unsigned char	buf[2];
	buf[0] = 2;
	buf[1] = data;
	zxlinux_send(SEND_QUEUE,buf,2);
}


void
zxlinux_msg(char *str)
{
	unsigned char	*p, *e, buf[256];
	  /**/
	e = buf + sizeof(buf);
	p = buf;
	*p++ = 3;
	for(; p < e && *str != 0; ++str){
		*p++ = *(unsigned char*)str;
	}
	zxlinux_send(SEND_QUEUE,buf,p-buf);
}


int
zxlinux_start()
{
	PROC_INI	pak;
	OBJECT_NAME	code, proc;

	if((code = code_create_file(name_generate(),ZXLINUX_FILE)) == -1){
		TmpAlert("ERR: code_create_file");
		return 0;
	}
	proc = ZXLINUX_PROC;
	pak.type	= SYSTEM_THREAD;	/* ! TASK */
	pak.priority	= 10000;
	pak.stack_size	= 0x1000;
	pak.code	= code;
	pak.message	= 0;
	if(proc_create(proc,&pak) == -1){
		TmpAlert("ERR: proc_create");
		code_delete(code);
		return 0;
	}
	if(proc_start(proc) == -1){
		TmpAlert("ERR: proc_start");
		proc_delete(proc);
		code_delete(code);
		return 0;
	}
	zxlinux_code = code;
	zxlinux_proc = proc;
	return 1;
}



int
zxlinux_end()
{
	/* send kill event to zxlinux_proc */
	zxlinux_msg(__FUNCTION__"\n");
	zxlinux_sendcmd(1);
#if 0
	if (zxlinux_proc) {
		proc_stop(zxlinux_proc);
		proc_delete(zxlinux_proc);
	}
	if (zxlinux_code) {
		code_delete(zxlinux_code);
	}
#endif
#if 0
	zxlinux_queue_dispose(SEND_QUEUE);
#endif
	return 1;
}

#if 0
int
zxlinux_end2()
{
	/* send kill event to zxlinux_proc */
	zxlinux_msg(__FUNCTION__"\n");
#if 1
	ValDump("zxlinux_end2: zxlinux_proc",zxlinux_proc,1);
	if (zxlinux_proc) {
		proc_stop(zxlinux_proc);
		proc_delete(zxlinux_proc);
	}
	if (zxlinux_code) {
		code_delete(zxlinux_code);
	}
#endif
#if 0
	zxlinux_queue_dispose(SEND_QUEUE);
#endif
	return 1;
}

int
zxps_start()
{
	PROC_INI	pak;
	OBJECT_NAME	code, proc;
	if((code = code_create_file(name_generate(),"F1:ZXPS.BIN")) == -1){
		TmpAlert(__FUNCTION__" ERR: code_create_file");
		return 0;
	}
	proc = str_to_name("zxps");
	pak.type	= SYSTEM_THREAD;	/* ! TASK */
	pak.priority	= 10000;
	pak.stack_size	= 0x1000;
	pak.code	= code;
	pak.message	= 0;
	if(proc_create(proc,&pak) == -1){
		TmpAlert(__FUNCTION__" ERR: proc_create");
		code_delete(code);
		return 0;
	}
	if(proc_start(proc) == -1){
		TmpAlert(__FUNCTION__" ERR: proc_start");
		proc_delete(proc);
		code_delete(code);
		return 0;
	}
	return 1;
}
#endif

/* EOF */
