/* ZxLinux key event */

/*
	zxlinux_key(Message)
	zlkey_start()
 */

/* #define KEY_DEBUG0	/**/
/* #define KEY_DEBUG	/* send to comm queue */

#include <zheaders.h>
#include <keydcode.h>

static USHORT
key_unknown(key)
USHORT key;
{
	if (key == 0x7f) return 0;
	if (key <= 0x03) return 1;
	if (key >= 0x60) return 1;
	return 0;
}


static USHORT
key_shift(key)
USHORT key;
{
	switch (key) {

	case _OKM_0: return '~';
	case _OKM_1: return '!';
	case _OKM_2: return '"';
	case _OKM_3: return '#';
	case _OKM_4: return '$';
	case _OKM_5: return '%';
	case _OKM_6: return '&';
	case _OKM_7: return '\'';
	case _OKM_8: return '(';
	case _OKM_9: return ')';

	case _OKM_COLON: return '*';
	case _OKM_SEMICOLON: return '+';
	case _OKM_COMMA: return '<';
	case _OKM_MINUS: return '=';
	case _OKM_PERIOD: return '>';
	case _OKM_SLASH: return '?';

	case '[': return '{';
	case ']': return '}';
	case '\\': return '|';
	case '^': return '_';
	case '@': return '`';

	default: return key;
	}
}


static USHORT
key_no_shift(key)
USHORT key;
{
	if (_OKM_A <= key && key <= _OKM_Z) return key - 'A' + 'a';

	if (key == _OKM_CR) return '\n'; /* '\r'? */

	return key;
}


static USHORT
key_ctrl(key)
USHORT key;
{
	if (_OKM_A <= key && key <= _OKM_Z) return key - 'A' + 1;
	return key;
}


int
zxlinux_key(Message)
MESSAGE *Message;
{
	USHORT key;
#ifdef KEY_DEBUG0
	char buf[256];
#endif KEY_DEBUG0

	if (Message->KeyDrvDown.KeyRepeat == KEY_REPEAT) return 1;
	if (key_unknown(Message->KeyDrvDown.KeyCode)) return 1;

	key = Message->KeyDrvDown.KeyCode;
	if (Message->KeyDrvDown.KeyAttr == MODIF_Ctrl) {
		key = key_ctrl(key);
	} else if (Message->KeyDrvDown.KeyAttr == MODIF_Shift) {
		key = key_shift(key);
	} else {
		key = key_no_shift(key);
	}

#ifdef KEY_DEBUG0
	sprintf(buf, "KeyDrvDown (%d=='%c')", key, (key<' '||key==0x7f)?'.':key);
	TmpAlert(buf);
#endif KEY_DEBUG0
	zxlinux_sendchar(key);

	return 1;
}


int
zlkey_start()
{
	if (KeyDrvOpen(NULL /*&KBType*/ , 1) == 0) {
		TmpAlert("Key Open Error");
		return 0;
	}
	return 1;
}


int
zlkey_end()
{
	KeyDrvClose(1);
	return 1;
}


int
zl_keypad_open()
{
	/* send keypad_open event to zxlinux */
	zxlinux_msg(__FUNCTION__"\n");
}


int
zl_keypad_close()
{
	/* send keypad_close event to zxlinux */
	zxlinux_msg(__FUNCTION__"\n");
}


/* EOF */
